//////////////////////////////////////////////////////////////////////
//  $$root$$.cpp - a minimal external module for NeatTools
//                     generated by Rob Salgado's ModuleMaker
//
//
//////////////////////////////////////////////////////////////////////

#if !defined( _$$root$$_h )
#define _$$root$$_h

//include the header files of the base class (here, JAddObj)
//
#include "JAddObj.h"

//----------------------------------------------------------------
//
//  class $$root$$
//

class
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
$$root$$ : public JAddObj { //derives from base class

  protected:

    //----------------------------------------------
    // PERSISTENCY-RELATED METHODS
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);

  public:
    enum { INTEGER_INPUT, STRING_INPUT , NUMBER_OF_INPUTS};     //convenient labels for 2 inputs
    enum { INTEGER_OUTPUT, STRING_OUTPUT, NUMBER_OF_OUTPUTS };  //convenient labels for 2 outputs
    //----------------------------------------------
    // BASIC METHODS  [ Register() is declared in JObject ]
    $$root$$(); //constructor 
		//(Note: loading an external module instantiates one member of the class,
		//		 which exists until NeatTools is shutdown.
		//       If the EM-toolbar is shown, another member is instantiated,
		//		 which exists until the toolbar is hidden.)

    ///$$root$$(const $$root$$ & src);  //if you define your own copy constructor
	///~$$root$$(); //destructor 

	///customize, if you need this functionality
	//virtual void startup();	//called after the constructor for new modules on the desktop [respond to system]
	//virtual void reset();		//called after the constructor for copied modules on the desktop  [reset states]
	//virtual void close();		//called before the destructor for modules on the desktop [closes all handles]


    virtual const char* className() const;
    virtual JObject* clone() const;

    //----------------------------------------------
    // EVENT-BROADCAST-RELATED METHODS
    virtual void engine(int n, JLinkObj& link);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    
    //----------------------------------------------
    // DISPLAY-RELATED METHODS
    virtual void paint(JGraphics g, double dx, double dy, 
                    JRegion& rgn, double scale);
    //----------------------------------------------
    // INFORMATION-RELATED METHODS
    virtual int inputType(int n);
    virtual int outputType(int n);
    virtual boolean inputAllowed(int n);
    virtual boolean outputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);

  protected:

    //----------------------------------------------
    //  DATA
    boolean doRepaint;  // flag: repaint needed
                        // if something has changed
    
    //----------------------------------------------
    //  PERSISTENT DATA
    int     persistentInteger1;
    JString persistentString1;
};

#endif
