#include "JCSVFileWriterObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"
#include <malloc.h>
#include <string.h>
static char* newstrcpy( char* buf ) {
	char* result = (char*)malloc( strlen( buf ) + 1 );
	strcpy( result, buf );
	return( result );
}
char* theJCSVFileWriterObj = JCSVFileWriterObj().Register();


void JCSVFileWriterObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "file", file);
  putInteger(os, "writeAfter", writeAfter );
}

void JCSVFileWriterObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject* obj_file = getObject( dict, "file");
  if ( obj_file ) file = *(JString*)obj_file;
  writeAfter = getInteger( dict, "writeAfter" );
}

const char* JCSVFileWriterObj::className() const { return "JCSVFileWriterObj";}


JObject* JCSVFileWriterObj::clone() const { return new JCSVFileWriterObj(*this);}


// class constructor
JCSVFileWriterObj::JCSVFileWriterObj() {
  igm = 1 + 1 + 1 + MAX_INPUTS;
  ogm = 0;
  on = 0;
  counter = 0;
  writeCounter = 0;
  writeAfter = 1;
  r0 = 0;
  for ( int i = 0; i < MAX_INPUTS; i++ ) {
	  rin[i] = 0;
  }
  outStreamAvailable = 0;
}


void JCSVFileWriterObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  char buf[100];
  sprintf( buf, "W CSV (%d)", writeAfter );
  drawText(g, JString(buf), rect);
}


boolean JCSVFileWriterObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JCSVFileWriterObj::inputTag(int n) {
  char* tag[] = {
    "on",
	"counter",
	"outFile",
    "r1",
    "r2",
    "r3",
    "r4",
    "r5",
    "r6",
    "r7",
    "r8",
    "r9",
    "r10",
	"r11",
	"r12",
	"r13",
	"r14",
	"r15",
	"r16",
	"r17",
	"r18",
	"r19",
	"r20",
	"r21",
	"r22",
	"r23",
	"r24",
	"r25",
	"r26",
	"r27",
	"r28",
	"r29",
	"r30",
	"r31",
	"r32",
	"r33",
	"r34",
	"r35",
	"r36",
	"r37",
	"r38",
	"r39",
	"r40",
	"r41" };
  return( tag[n] );
}


JString JCSVFileWriterObj::outputTag(int n) {
  char* tag[] = {
    "counter",
    "r1",
    "r2",
    "r3",
    "r4",
    "r5",
    "r6",
    "r7",
    "r8",
    "r9",
    "r10",
	"r11",
	"r12",
	"r13",
	"r14",
	"r15",
	"r16",
	"r17",
	"r18",
	"r19",
	"r20",
	"r21",
	"r22",
	"r23",
	"r24",
	"r25",
	"r26",
	"r27",
	"r28",
	"r29",
	"r30",
	"r31",
	"r32",
	"r33",
	"r34",
	"r35",
	"r36",
	"r37",
	"r38",
	"r39",
	"r40",
	"r41"

  };
  return( tag[n] );
}
int JCSVFileWriterObj::outputType( int n ) {
  if ( n == 0 ) return JIntegerData::id;
  return JIntegerData::id;
}
int JCSVFileWriterObj::inputType( int n ) {
  if ( n < 2 ) return JIntegerData::id;
  else if ( n == 2 ) return JStringData::id;
  return JIntegerData::id;
}

JFRect JCSVFileWriterObj::inputArea(int n) {
	if ( n <3 ) 
  return topArea( n, 0, 3, 0.25 );
	else
		return( leftArea( n, 0, MAX_INPUTS, 0.02 ));
}


JFRect JCSVFileWriterObj::outputArea(int n) {
  return rightArea(n, 0, 1 );
}


int JCSVFileWriterObj::inputFace(int n) {
	if ( n <3 ) 
  return TOP;
	else return( LEFT );
}


int JCSVFileWriterObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JCSVFileWriterObj::inputPoint(int n, JLinkObj& link) {
	if ( n <3 ) 
  return topPoint(n, link, 0, 3 );
	else
		return leftPoint( n, link, 0, MAX_INPUTS, 0.02 );
}


JFPoint JCSVFileWriterObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1 );
}


void JCSVFileWriterObj::access(int n, JLinkObj& link, const JDataType& data) {
 
}

#include <ctype.h>
char dbgbuf[200];
char* grabDouble( char* scanner, double* xresult ) {
	if ( scanner == NULL ) {
		return( NULL );
	}
	//JComponent::debug( scanner );
	double result = 0;
	int fraction = 0;
	int fractionFactor = 1;
	bool mainResult = true;
	while ( *scanner ) {
		if ( isdigit( *scanner )) {
			if ( mainResult ) {
				result = result*10 + (*scanner - '0');
				sprintf( dbgbuf, "result now %e", result );
				//JComponent::debug( newstrcpy( dbgbuf ));
			} else {
				fraction = fraction * 10 + (*scanner - '0');
				fractionFactor *= 10;
				sprintf( dbgbuf, "fraction part now %d", fraction );
				//JComponent::debug( newstrcpy( dbgbuf ));
			}
		} else if ( *scanner == '.' ) {
			mainResult = false;
		} else {
			scanner++;
			*xresult = result + (double)fraction/(double)fractionFactor;
			sprintf( dbgbuf, "double value is %e", *xresult );
			//JComponent::debug( newstrcpy( dbgbuf ));
			return( scanner );
		}
		scanner++;
	}
	return( NULL );
}
char* grabInt( char* scanner, int* xresult ) {
	int result = 0;
	if ( scanner == NULL ) {
		return( NULL );
	}
	//JComponent::debug( scanner );
	while ( *scanner ) {
		if ( isdigit( *scanner )) {
			result = result*10 + (*scanner - '0');
		} else {
			scanner++;
			*xresult = result;
			return( scanner );
		}
		scanner++;
	}
	return( NULL );
}

void JCSVFileWriterObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case ON:
    link.access(JIntegerData(on));
	if ( on ) {
		outFile = JFile( file );
			//JComponent::debug( "File exists" );
			outputStream = fopen( file, "w" );
			if ( outputStream == null ) {
				outStreamAvailable = 0;
			} else {
				outStreamAvailable = 1;
			}
	} else {
		if ( outStreamAvailable ) {
			fclose( outputStream );
			outStreamAvailable = 0;
		}
	}
    break;

  case 1:
	  link.access( JIntegerData( counter ));
	  writeCounter++;
	  break;

  case 2:
	  link.access( JStringData( file ));
	  break;

  default:
	  int dd;
	      link.access(JIntegerData(dd));
		  rin[n - 3 ] = dd;
		  if ( outStreamAvailable ) {
		  writeCounter++;
		  if ( writeCounter >= writeAfter ) {
			  writeCounter = 0;
			  fprintf( outputStream, "%d,", counter );
			  counter++;
			  for ( int i = 0; i < MAX_INPUTS; i++ ) {
				  fprintf( outputStream, "%d,", rin[i] );
			  }
			  fprintf( outputStream, "\n" );
		  }
		  }

    break;
  }
}


JArray JCSVFileWriterObj::getProperties() {
  JArray properties;
  properties.append(JStringProperty("file", file));
  properties.append(JIntegerProperty("writeAfter",writeAfter,1,40));
  return properties;
}


boolean JCSVFileWriterObj::updateProperty(JProperty& prop) {
  if (prop.getName() == JString("file")) {
    file = ((JStringProperty*)&prop)->value;
    return true;
  } else if ( prop.getName() == JString("writeAfter")) {
	  writeAfter = ((JIntegerProperty*)&prop)->value;
	  return( true );
  }
  return false;
}


